
class Producer extends Thread {
  Port out ;

  public Producer (Port out) {
    this.out = out ;
  }

  public void run() {
    while(true)
      out.sendInt(1) ;
  }
}

class Consumer extends Thread {
  Port in ;

  public Consumer (Port in) {
    this.in = in ;
  }

  public void run() {
    while(true) {
      int result = in.recvInt() ;
      System.out.println("" + result) ;
    }
  }
}

class Accum extends Thread {
  Port in, out ;
  int total ;

  public Accum (Port in, Port out) {
    this.in  = in ;
    this.out = out ;

    total = 0 ;
  }

  public void run() {
    while(true) {
      total += in.recvInt() ;
      out.sendInt(total) ;
    }
  }
}

public class Eg2 {
  public static void main(String args[]) {
    Port P1 = new Port() ;
    Port Q1 = new Port() ;

    Port P2 = new Port() ;
    Port Q2 = new Port() ;

    Port.channel(P1, Q1) ;
    Port.channel(P2, Q2) ;

    (new Producer(P1)).start()  ;
    (new Accum(Q1, P2)).start() ;
    (new Consumer(Q2)).start()  ;
  }
}


